Codeforces Round #334 (Div. 2) B. More Cowbell (贪心)

来源:互联网 发布:学vb用什么软件 编辑:程序博客网 时间:2024/05/15 23:47

传送门:B. More Cowbell

描述:

B. More Cowbell
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Kevin Sun wants to move his precious collection of n cowbells from Naperthrill to Exeter, where there is actually grass instead of corn. Before moving, he must pack his cowbells into k boxes of a fixed size. In order to keep his collection safe during transportation, he won't place more than two cowbells into a single box. Since Kevin wishes to minimize expenses, he is curious about the smallest size box he can use to pack his entire collection.

Kevin is a meticulous cowbell collector and knows that the size of his i-th (1 ≤ i ≤ n) cowbell is an integer si. In fact, he keeps his cowbells sorted by size, so si - 1 ≤ si for any i > 1. Also an expert packer, Kevin can fit one or two cowbells into a box of size s if and only if the sum of their sizes does not exceed s. Given this information, help Kevin determine the smallest s for which it is possible to put all of his cowbells into k boxes of size s.

Input

The first line of the input contains two space-separated integers n and k (1 ≤ n ≤ 2·k ≤ 100 000), denoting the number of cowbells and the number of boxes, respectively.

The next line contains n space-separated integers s1, s2, ..., sn (1 ≤ s1 ≤ s2 ≤ ... ≤ sn ≤ 1 000 000), the sizes of Kevin's cowbells. It is guaranteed that the sizes si are given in non-decreasing order.

Output

Print a single integer, the smallest s for which it is possible for Kevin to put all of his cowbells into k boxes of size s.

Examples
input
2 12 5
output
7
input
4 32 3 5 9
output
9
input
3 23 5 7
output
8
Note

In the first sample, Kevin must pack his two cowbells into the same box.

In the second sample, Kevin can pack together the following sets of cowbells: {2, 3}{5} and {9}.

In the third sample, the optimal solution is {3, 5} and {7}.

题意:

n个东西,k个箱子,一个箱子能放两个东西,东西有重量,一个箱子里面东西的重量就是他的容量,求最小容量方法中的最大容量

思路:

分情况:如果n<=k,那么ans为a[n],如果n>k,那么就要贪心了,选取前n-k个东西,然后将其倒序插入剩余的东西中,过程中取最大值即可

代码:

#include <bits/stdc++.h>using  namespace  std;const int N=1e6+10;int n,k,s[N];int  main(){  std::ios::sync_with_stdio(false);  std::cin.tie(0);  while(cin>>n>>k){    for(int i=1; i<=n; i++){      cin>>s[i];    }    if(n<=k)cout<<s[n]<<endl;    else{      int ans=s[n],j=n-k+1;      for(int i=n-k; i>=1; i--){        ans=max(ans, s[i]+s[j++]);      }      cout<<ans<<endl;    }  }  return 0;}





0 0
原创粉丝点击